package com.example.ReactiveCache.Controller;

import com.example.ReactiveCache.Entity.Coffee;
import org.springframework.cache.annotation.Cacheable;
import org.springframework.data.redis.core.ReactiveRedisOperations;
import org.springframework.web.bind.annotation.*;
import reactor.core.publisher.Flux;
import reactor.core.publisher.Mono;

import java.util.UUID;

@RestController
@RequestMapping("/coffees")
public class CoffeeController {

    private final ReactiveRedisOperations<String, Coffee> coffeeOps;

    CoffeeController(ReactiveRedisOperations<String, Coffee> coffeeOps){
        this.coffeeOps = coffeeOps;
    }

    @PostMapping
    public Mono<Boolean> saveCoffeeData(@RequestBody Mono<Coffee> coffeeMono){
        //request.map(req -> { // Your logic here String response = "Example response";}
        //return coffeeOps.set()
//        String mapId = coffeeMono.map(p -> {
//            String message = p.getId();
//            System.out.println("message========="+message);
//            return message;
//        }).toString();
        return coffeeMono
               // .flatMap(coffee -> coffeeOps.opsForHash().put(UUID.randomUUID().toString(),"Coffee", coffee));
                .flatMap(coffee -> coffeeOps.opsForValue().set(UUID.randomUUID().toString(), coffee));
//        if(booleanMono.block()) return coffeeOps.keys(mapId).flatMap(coffeeOps.opsForValue()::get);
//        else{
//            return Flux.empty();
//        }
    }
    @GetMapping
    public Flux<Coffee> getAllCoffeeDetails(){
        return coffeeOps.keys("*").flatMap(coffeeOps.opsForValue()::get);
    }

    @GetMapping("/{color}")
    public Mono<Coffee> getCoffeeDetailsById(@PathVariable String color){
        return coffeeOps.opsForValue().get(color);
    }
}
